## sord 0.10.4~dfsg0

=== wscript ===
#!/usr/bin/env python
import glob
import os
import subprocess
import waflib.Logs as Logs
import waflib.Options as Options
import waflib.extras.autowaf as autowaf

# Library and package version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
SORD_VERSION       = '0.10.4'
SORD_MAJOR_VERSION = '0'

# Mandatory waf variables
APPNAME = 'sord'        # Package name for waf dist
VERSION = SORD_VERSION  # Package version for waf dist
top     = '.'           # Source directory
out     = 'build'       # Build directory

def options(opt):
    opt.load('compiler_c')
    opt.load('compiler_cxx')
    autowaf.set_options(opt)
    opt.add_option('--no-utils', action='store_true', dest='no_utils',
                   help='Do not build command line utilities')
    opt.add_option('--test', action='store_true', dest='build_tests',
                   help='Build unit tests')
    opt.add_option('--static', action='store_true', dest='static',
                   help='Build static library')
    opt.add_option('--no-shared', action='store_true', dest='no_shared',
                   help='Do not build shared library')
    opt.add_option('--static-progs', action='store_true', dest='static_progs',
                   help='Build programs as static binaries')
    opt.add_option('--dump', type='string', default='', dest='dump',
                   help='Dump debugging output (iter, search, write, all)')

def configure(conf):
    conf.load('compiler_c')
    if Options.options.build_tests:
        try:
            conf.load('compiler_cxx')
        except:
            Logs.warn("No C++ compiler, sordmm.hpp compile test skipped")
            pass
        
    autowaf.configure(conf)
    autowaf.set_c99_mode(conf)
    autowaf.display_header('Sord configuration')

    conf.env.BUILD_TESTS  = Options.options.build_tests
    conf.env.BUILD_UTILS  = not Options.options.no_utils
    conf.env.BUILD_SHARED = not Options.options.no_shared
    conf.env.STATIC_PROGS = Options.options.static_progs
    conf.env.BUILD_STATIC = (Options.options.static or
                             Options.options.static_progs)

    if conf.env.BUILD_TESTS:
        conf.check(lib         = 'gcov',
                   define_name = 'HAVE_GCOV',
                   mandatory   = False)

    autowaf.check_pkg(conf, 'serd-0', uselib_store='SERD',
                      atleast_version='0.18.0', mandatory=True)
    autowaf.check_pkg(conf, 'libpcre', uselib_store='PCRE', mandatory=False)

    # Parse dump options and define things accordingly
    dump = Options.options.dump.split(',')
    all = 'all' in dump
    if all or 'iter' in dump:
        autowaf.define(conf, 'SORD_DEBUG_ITER', 1)
    if all or 'search' in dump:
        autowaf.define(conf, 'SORD_DEBUG_SEARCH', 1)
    if all or 'write' in dump:
        autowaf.define(conf, 'SORD_DEBUG_WRITE', 1)

    autowaf.define(conf, 'SORD_VERSION', SORD_VERSION)
    autowaf.set_lib_env(conf, 'sord', SORD_VERSION)
    conf.write_config_header('sord_config.h', remove=False)

    autowaf.display_msg(conf, 'Utilities', bool(conf.env.BUILD_UTILS))
    autowaf.display_msg(conf, 'Unit tests', bool(conf.env.BUILD_TESTS))
    autowaf.display_msg(conf, 'Debug dumping', dump)
    print('')

def build(bld):
    # C/C++ Headers
    includedir = '${INCLUDEDIR}/sord-%s/sord' % SORD_MAJOR_VERSION
    bld.install_files(includedir, bld.path.ant_glob('sord/*.h'))
    bld.install_files(includedir, bld.path.ant_glob('sord/*.hpp'))

    # Pkgconfig file
    autowaf.build_pc(bld, 'SORD', SORD_VERSION, SORD_MAJOR_VERSION, 'SERD',
                     {'SORD_MAJOR_VERSION' : SORD_MAJOR_VERSION})

    source = 'src/sord.c src/syntax.c'

    libflags = ['-fvisibility=hidden']
    libs     = ['m']
    defines  = []
    if bld.env.MSVC_COMPILER:
        libflags = []
        libs     = []
        defines  = ['snprintf=_snprintf']

    # Shared Library
    if bld.env.BUILD_SHARED:
        obj = bld(features        = 'c cshlib',
                  source          = source,
                  includes        = ['.', './src'],
                  export_includes = ['.'],
                  name            = 'libsord',
                  target          = 'sord-%s' % SORD_MAJOR_VERSION,
                  vnum            = SORD_VERSION,
                  install_path    = '${LIBDIR}',
                  libs            = libs,
                  defines         = defines + ['SORD_SHARED', 'SORD_INTERNAL'],
                  cflags          = libflags)
        autowaf.use_lib(bld, obj, 'SERD')
    
    # Static Library
    if bld.env.BUILD_STATIC:
        obj = bld(features        = 'c cstlib',
                  source          = source,
                  includes        = ['.', './src'],
                  export_includes = ['.'],
                  name            = 'libsord_static',
                  target          = 'sord-%s' % SORD_MAJOR_VERSION,
                  vnum            = SORD_VERSION,
                  install_path    = '${LIBDIR}',
                  libs            = libs,
                  defines         = ['SORD_INTERNAL'])
        autowaf.use_lib(bld, obj, 'SERD')

    if bld.env.BUILD_TESTS:
        test_libs   = libs
        test_cflags = ['']
        if bld.is_defined('HAVE_GCOV'):
            test_libs   += ['gcov']
            test_cflags += ['-fprofile-arcs', '-ftest-coverage']

        # Profiled static library for test coverage
        obj = bld(features     = 'c cstlib',
                  source       = source,
                  includes     = ['.', './src'],
                  name         = 'libsord_profiled',
                  target       = 'sord_profiled',
                  install_path = '',
                  defines      = defines,
                  cflags       = test_cflags,
                  lib          = test_libs)
        autowaf.use_lib(bld, obj, 'SERD')

        # Unit test program
        obj = bld(features     = 'c cprogram',
                  source       = 'src/sord_test.c',
                  includes     = ['.', './src'],
                  use          = 'libsord_profiled',
                  lib          = test_libs,
                  target       = 'sord_test',
                  install_path = '',
                  defines      = defines,
                  cflags       = test_cflags)
        autowaf.use_lib(bld, obj, 'SERD')

        # Static profiled sordi for tests
        obj = bld(features     = 'c cprogram',
                  source       = 'src/sordi.c',
                  includes     = ['.', './src'],
                  use          = 'libsord_profiled',
                  lib          = test_libs,
                  target       = 'sordi_static',
                  install_path = '',
                  defines      = defines,
                  cflags       = test_cflags)
        autowaf.use_lib(bld, obj, 'SERD')

        # C++ build test
        if bld.env.COMPILER_CXX:
            obj = bld(features     = 'cxx cxxprogram',
                      source       = 'src/sordmm_test.cpp',
                      includes     = ['.', './src'],
                      use          = 'libsord_profiled',
                      lib          = test_libs,
                      target       = 'sordmm_test',
                      install_path = '',
                      defines      = defines)
            autowaf.use_lib(bld, obj, 'SERD')

    # Utilities
    if bld.env.BUILD_UTILS:
        for i in ['sordi', 'sord_validate']:
            obj = bld(features     = 'c cprogram',
                      source       = 'src/%s.c' % i,
                      includes     = ['.', './src'],
                      use          = 'libsord',
                      lib          = libs, 
                      target       = i,
                      install_path = '${BINDIR}',
                      defines      = defines)
            if not bld.env.BUILD_SHARED or bld.env.STATIC_PROGS:
                obj.use = 'libsord_static'
            if bld.env.STATIC_PROGS:
                obj.env.SHLIB_MARKER = obj.env.STLIB_MARKER
                obj.linkflags        = ['-static', '-Wl,--start-group']
            autowaf.use_lib(bld, obj, 'SERD PCRE')

    # Documentation
    autowaf.build_dox(bld, 'SORD', SORD_VERSION, top, out)

    # Man pages
    bld.install_files('${MANDIR}/man1', bld.path.ant_glob('doc/*.1'))

    bld.add_post_fun(autowaf.run_ldconfig)
    if bld.env.DOCS:
        bld.add_post_fun(fix_docs)

def lint(ctx):
    subprocess.call('cpplint.py --filter=+whitespace/comments,-whitespace/tab,-whitespace/braces,-whitespace/labels,-build/header_guard,-readability/casting,-readability/todo,-build/include src/*.* sord/* src/zix/*.*', shell=True)

def fix_docs(ctx):
    if ctx.cmd == 'build':
        autowaf.make_simple_dox(APPNAME)

def upload_docs(ctx):
    os.system('rsync -ravz --delete -e ssh build/doc/html/ drobilla@drobilla.net:~/drobilla.net/docs/sord/')

def test(ctx):
    blddir = autowaf.build_dir(APPNAME, 'tests')
    try:
        os.makedirs(blddir)
    except:
        pass

    for i in glob.glob(blddir + '/*.*'):
        os.remove(i)

    srcdir   = ctx.path.abspath()
    orig_dir = os.path.abspath(os.curdir)

    os.chdir(srcdir)

    good_tests = glob.glob('tests/test-*.ttl')
    good_tests.sort()

    os.chdir(orig_dir)

    autowaf.pre_test(ctx, APPNAME)

    os.environ['PATH'] = '.' + os.pathsep + os.getenv('PATH')

    nul = os.devnull

    autowaf.run_tests(ctx, APPNAME, [
            'sordi_static file://%s/tests/manifest.ttl > %s' % (srcdir, nul),
            'sordi_static %s/tests/UTF-8.ttl > %s' % (srcdir, nul),
            'sordi_static -v > %s' % nul,
            'sordi_static -h > %s' % nul,
            'sordi_static -s "<foo> a <#Thingie> ." file:///test > %s' % nul,
            'sordi_static %s > %s' % (nul, nul)],
                      0, name='sordi-cmd-good')

    autowaf.run_tests(ctx, APPNAME, [
            'sordi_static > %s' % nul,
            'sordi_static ftp://example.org/unsupported.ttl > %s' % nul,
            'sordi_static -i > %s' % nul,
            'sordi_static -o > %s' % nul,
            'sordi_static -z > %s' % nul,
            'sordi_static -p > %s' % nul,
            'sordi_static -c > %s' % nul,
            'sordi_static -i illegal > %s' % nul,
            'sordi_static -o illegal > %s' % nul,
            'sordi_static -i turtle > %s' % nul,
            'sordi_static /no/such/file > %s' % nul],
                      1, name='sordi-cmd-bad')

    autowaf.run_tests(ctx, APPNAME, ['sord_test'])

    commands = []
    for test in good_tests:
        base_uri = 'http://www.w3.org/2001/sw/DataAccess/df1/' + test.replace('\\', '/')
        commands += [ 'sordi_static "%s" "%s" > %s.out' % (
                os.path.join(srcdir, test), base_uri, test) ]

    autowaf.run_tests(ctx, APPNAME, commands, 0, name='good')

    Logs.pprint('BOLD', '\nVerifying turtle => ntriples')
    for test in good_tests:
        out_filename = test + '.out'
        cmp_filename = srcdir + '/' + test.replace('.ttl', '.out')
        if not os.access(out_filename, os.F_OK):
            Logs.pprint('RED', 'FAIL: %s output is missing' % test)
        else:
            out_lines = sorted(open(out_filename).readlines())
            cmp_lines = sorted(open(cmp_filename).readlines())
            if out_lines != cmp_lines:
                Logs.pprint('RED', 'FAIL: %s is incorrect' % out_filename)
            else:
                Logs.pprint('GREEN', 'Pass: %s' % test)

    autowaf.post_test(ctx, APPNAME)

=== debian/changelog ===
sord (0.10.4~dfsg0-1) experimental; urgency=low

  * New upstream release.
  * Install sord_validate and its manpage.
  * Refresh patches.

 -- Alessio Treglia <alessio@debian.org>  Mon, 05 Nov 2012 10:20:51 +0000

sord (0.10.0~dfsg0-1) experimental; urgency=low

  * New upstream release.
  * Refresh patches.
  * Bump build-dep on libserd >= 0.18.0~dfsg0.
  * Implement a mechanism to repack the upstream tarball.
  * Install NEWS as upstream changelog.
  * Refresh symbols.

 -- Alessio Treglia <alessio@debian.org>  Sun, 02 Sep 2012 17:49:46 +0200

=== debian/control ===
Source: sord
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Alessio Treglia <alessio@debian.org>
Build-Depends:
 debhelper (>= 9),
 doxygen,
 graphviz,
 libserd-dev (>= 0.18.0~dfsg0),
 pkg-config,
 python
Standards-Version: 3.9.3
Homepage: http://drobilla.net/software/sord/
Vcs-Git: git://anonscm.debian.org/pkg-multimedia/sord.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/sord.git

Package: libsord-0-0
Section: utils
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 sordi
Description: library for storing RDF data in memory
 Sord is a lightweight C library for storing Resource
 Description Framework (RDF) data in memory.
 .
 Sord includes man pages for the library (man sord) and a
 simple command line utility (man sordi).

Package: libsord-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libserd-dev,
 libsord-0-0 (= ${binary:Version}),
 ${misc:Depends}
Suggests:
 libsord-doc
Recommends:
 pkg-config
Description: library for storing RDF data in memory (development files)
 Sord is a lightweight C library for storing Resource
 Description Framework (RDF) data in memory.
 .
 This package provides the development headers.

Package: sordi
Architecture: any
Section: text
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: library for storing RDF data in memory - utilities
 Sord is a lightweight C library for storing Resource
 Description Framework (RDF) data in memory.
 .
 This package provides the 'sordi' and 'sord_validate' utilities.

Package: libsord-doc
Section: doc
Architecture: all
Enhances:
 libsord-dev
Depends:
 ${misc:Depends}
Recommends:
 libjs-jquery
Description: library for storing RDF data in memory (documentation)
 Sord is a lightweight C library for storing Resource
 Description Framework (RDF) data in memory.
 .
 This package provides the developer's reference for sord.

Package: sord-dbg
Priority: extra
Section: debug
Architecture: any
Multi-Arch: same
Depends:
 libsord-0-0 (= ${binary:Version}),
 ${misc:Depends}
Description: library for storing RDF data in memory (debugging symbols)
 Sord is a lightweight C library for storing Resource
 Description Framework (RDF) data in memory.
 .
 This package provides the debugging symbols for sord.

## sord 0.12.0~dfsg0

=== wscript ===
--- 
+++ 
@@ -10,7 +10,7 @@
 # major increment <=> incompatible changes
 # minor increment <=> compatible changes (additions)
 # micro increment <=> no interface changes
-SORD_VERSION       = '0.10.4'
+SORD_VERSION       = '0.12.0'
 SORD_MAJOR_VERSION = '0'
 
 # Mandatory waf variables

=== debian/changelog ===
sord (0.12.0~dfsg0-3) unstable; urgency=low

  * Upload to unstable.
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Tue, 07 May 2013 10:52:57 +0100

sord (0.12.0~dfsg0-2) experimental; urgency=low

  * Tighten libsord-dev's dependency on libserd-dev >= 0.18.0~.

 -- Alessio Treglia <alessio@debian.org>  Tue, 12 Mar 2013 16:51:17 +0000

sord (0.12.0~dfsg0-1) experimental; urgency=low

  * New upstream release.
  * Fix libsord-doc.install.
  * Refresh symbols file.

 -- Alessio Treglia <alessio@debian.org>  Mon, 11 Mar 2013 02:33:32 +0000

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  libserd-dev (>= 0.18.0~dfsg0),
  pkg-config,
  python
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://drobilla.net/software/sord/
 Vcs-Git: git://anonscm.debian.org/pkg-multimedia/sord.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/sord.git
@@ -38,7 +38,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libserd-dev,
+ libserd-dev (>= 0.18.0~dfsg0),
  libsord-0-0 (= ${binary:Version}),
  ${misc:Depends}
 Suggests:

=== debian/rules ===
#!/usr/bin/make -f

upstream_version ?= $(shell dpkg-parsechangelog | sed -rne 's/^Version: ([0-9.]+)(\+dfsg\d+)?.*$$/\1/p')
dfsg_version = $(upstream_version)~dfsg0
pkg = $(shell dpkg-parsechangelog | sed -ne 's/^Source: //p')

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LDFLAGS+=-Wl,--as-needed
WAF = ./waf

%:
	dh $@

override_dh_auto_configure:
	$(WAF) configure \
		--prefix=/usr \
		--mandir=/usr/share/man \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--strict \
		--debug \
		--docs

override_dh_auto_build:
	$(WAF)

override_dh_auto_clean:
	$(WAF) clean || true
	find -name "*.pyc" -delete
	dh_auto_clean

override_dh_auto_install:
	$(WAF) install --destdir=$(CURDIR)/debian/tmp

override_dh_strip:
	dh_strip -plibsord-0-0 --dbg-package=sord-dbg
	dh_strip --remaining-packages

override_dh_installchangelogs:
	dh_installchangelogs NEWS

# get-orig-source to drop waf
get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=.
	tar -xf $(pkg)_$(upstream_version).orig.tar.bz2
	mv $(pkg)-$(upstream_version) $(pkg)-$(dfsg_version)
	cd $(pkg)-$(dfsg_version) ; python waf --help > /dev/null
	mv $(pkg)-$(dfsg_version)/.waf-*/* $(pkg)-$(dfsg_version)
	sed -i '/^#==>$$/,$$d' $(pkg)-$(dfsg_version)/waf
	rmdir $(pkg)-$(dfsg_version)/.waf-*
	find $(pkg)-$(dfsg_version)/ -name '*.pyc' -delete
	tar cf $(pkg)_$(dfsg_version).orig.tar $(pkg)-$(dfsg_version)
	xz -9fz $(pkg)_$(dfsg_version).orig.tar
	rm -rf $(pkg)-$(dfsg_version)

=== debian/watch ===
version=3
opts="uversionmangle=s/-/./,dversionmangle=s/~dfsg.*//" \
http://download.drobilla.net/sord-(.*)\.tar\.bz2

## sord 0.12.2~dfsg0

=== debian/changelog ===
sord (0.12.2~dfsg0-1) unstable; urgency=medium

  * New upstream release.
  * Added myself as uploader
  * Tuned get-orig-source.
  * Remove --debug from configure to cppflags be passed.
  * Bump Standards.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Thu, 14 Aug 2014 09:03:47 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Priority: optional
 Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
 Uploaders:
- Alessio Treglia <alessio@debian.org>
+ Alessio Treglia <alessio@debian.org>,
+ Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends:
  debhelper (>= 9),
  doxygen,
@@ -11,7 +12,7 @@
  libserd-dev (>= 0.18.0~dfsg0),
  pkg-config,
  python
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://drobilla.net/software/sord/
 Vcs-Git: git://anonscm.debian.org/pkg-multimedia/sord.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/sord.git

=== debian/rules ===
--- 
+++ 
@@ -17,7 +17,6 @@
 		--mandir=/usr/share/man \
 		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
 		--strict \
-		--debug \
 		--docs
 
 override_dh_auto_build:
@@ -51,3 +50,5 @@
 	tar cf $(pkg)_$(dfsg_version).orig.tar $(pkg)-$(dfsg_version)
 	xz -9fz $(pkg)_$(dfsg_version).orig.tar
 	rm -rf $(pkg)-$(dfsg_version)
+	mv $(pkg)_$(dfsg_version).orig.tar.xz ../$(pkg)_$(dfsg_version).orig.tar.xz
+	mv $(pkg)_$(upstream_version).orig.tar.bz2 ../$(pkg)_$(upstream_version).orig.tar.bz2

## sord 0.14.0~dfsg0

=== wscript ===
--- 
+++ 
@@ -2,6 +2,7 @@
 import glob
 import os
 import subprocess
+import sys
 import waflib.Logs as Logs
 import waflib.Options as Options
 import waflib.extras.autowaf as autowaf
@@ -10,7 +11,7 @@
 # major increment <=> incompatible changes
 # minor increment <=> compatible changes (additions)
 # micro increment <=> no interface changes
-SORD_VERSION       = '0.12.0'
+SORD_VERSION       = '0.14.0'
 SORD_MAJOR_VERSION = '0'
 
 # Mandatory waf variables
@@ -27,6 +28,8 @@
                    help='Do not build command line utilities')
     opt.add_option('--test', action='store_true', dest='build_tests',
                    help='Build unit tests')
+    opt.add_option('--no-coverage', action='store_true', dest='no_coverage',
+                   help='Do not use gcov for code coverage')
     opt.add_option('--static', action='store_true', dest='static',
                    help='Build static library')
     opt.add_option('--no-shared', action='store_true', dest='no_shared',
@@ -44,7 +47,7 @@
         except:
             Logs.warn("No C++ compiler, sordmm.hpp compile test skipped")
             pass
-        
+
     autowaf.configure(conf)
     autowaf.set_c99_mode(conf)
     autowaf.display_header('Sord configuration')
@@ -56,14 +59,23 @@
     conf.env.BUILD_STATIC = (Options.options.static or
                              Options.options.static_progs)
 
-    if conf.env.BUILD_TESTS:
-        conf.check(lib         = 'gcov',
-                   define_name = 'HAVE_GCOV',
-                   mandatory   = False)
+    if conf.env.BUILD_TESTS and not Options.options.no_coverage:
+        conf.check_cc(lib='gcov', define_name='HAVE_GCOV', mandatory=False)
 
     autowaf.check_pkg(conf, 'serd-0', uselib_store='SERD',
                       atleast_version='0.18.0', mandatory=True)
     autowaf.check_pkg(conf, 'libpcre', uselib_store='PCRE', mandatory=False)
+
+    if conf.env.HAVE_PCRE:
+        if conf.check(cflags=['-pthread'], mandatory=False):
+            conf.env.PTHREAD_CFLAGS    = ['-pthread']
+            conf.env.PTHREAD_LINKFLAGS = ['-pthread']
+        elif conf.check(linkflags=['-lpthread'], mandatory=False):
+            conf.env.PTHREAD_CFLAGS    = []
+            conf.env.PTHREAD_LINKFLAGS = ['-lpthread']
+        else:
+            conf.env.PTHREAD_CFLAGS    = []
+            conf.env.PTHREAD_LINKFLAGS = []
 
     # Parse dump options and define things accordingly
     dump = Options.options.dump.split(',')
@@ -118,7 +130,7 @@
                   defines         = defines + ['SORD_SHARED', 'SORD_INTERNAL'],
                   cflags          = libflags)
         autowaf.use_lib(bld, obj, 'SERD')
-    
+
     # Static Library
     if bld.env.BUILD_STATIC:
         obj = bld(features        = 'c cstlib',
@@ -190,12 +202,15 @@
 
     # Utilities
     if bld.env.BUILD_UTILS:
-        for i in ['sordi', 'sord_validate']:
+        utils = ['sordi']
+        if bld.env.HAVE_PCRE:
+            utils += ['sord_validate']
+        for i in utils:
             obj = bld(features     = 'c cprogram',
                       source       = 'src/%s.c' % i,
                       includes     = ['.', './src'],
                       use          = 'libsord',
-                      lib          = libs, 
+                      lib          = libs,
                       target       = i,
                       install_path = '${BINDIR}',
                       defines      = defines)
@@ -204,7 +219,11 @@
             if bld.env.STATIC_PROGS:
                 obj.env.SHLIB_MARKER = obj.env.STLIB_MARKER
                 obj.linkflags        = ['-static', '-Wl,--start-group']
-            autowaf.use_lib(bld, obj, 'SERD PCRE')
+            autowaf.use_lib(bld, obj, 'SERD')
+            if i == 'sord_validate':
+                autowaf.use_lib(bld, obj, 'PCRE')
+                obj.cflags    = bld.env.PTHREAD_CFLAGS
+                obj.linkflags = bld.env.PTHREAD_LINKFLAGS
 
     # Documentation
     autowaf.build_dox(bld, 'SORD', SORD_VERSION, top, out)
@@ -225,6 +244,9 @@
 
 def upload_docs(ctx):
     os.system('rsync -ravz --delete -e ssh build/doc/html/ drobilla@drobilla.net:~/drobilla.net/docs/sord/')
+    for page in glob.glob('doc/*.[1-8]'):
+        os.system('soelim %s | pre-grohtml troff -man -wall -Thtml | post-grohtml > build/%s.html' % (page, page))
+        os.system('rsync -avz --delete -e ssh build/%s.html drobilla@drobilla.net:~/drobilla.net/man/' % page)
 
 def test(ctx):
     blddir = autowaf.build_dir(APPNAME, 'tests')
@@ -252,12 +274,20 @@
 
     nul = os.devnull
 
+    snippet = '<s> <p> <o> .'
+    if sys.platform == "win32":
+        snippet = snippet.replace('<', '^<').replace('>', '^>')
+    else:
+        snippet = '"%s"' % snippet
+
     autowaf.run_tests(ctx, APPNAME, [
-            'sordi_static file://%s/tests/manifest.ttl > %s' % (srcdir, nul),
-            'sordi_static %s/tests/UTF-8.ttl > %s' % (srcdir, nul),
+            'sordi_static "file://%s/tests/manifest.ttl" > %s' % (srcdir, nul),
+            'sordi_static "%s/tests/UTF-8.ttl" > %s' % (srcdir, nul),
             'sordi_static -v > %s' % nul,
             'sordi_static -h > %s' % nul,
             'sordi_static -s "<foo> a <#Thingie> ." file:///test > %s' % nul,
+            'echo %s | sordi_static - http://example.org/' % snippet,
+            'echo %s | sordi_static -o turtle - http://example.org/' % snippet,
             'sordi_static %s > %s' % (nul, nul)],
                       0, name='sordi-cmd-good')
 
@@ -272,31 +302,4 @@
             'sordi_static -i illegal > %s' % nul,
             'sordi_static -o illegal > %s' % nul,
             'sordi_static -i turtle > %s' % nul,
-            'sordi_static /no/such/file > %s' % nul],
-                      1, name='sordi-cmd-bad')
-
-    autowaf.run_tests(ctx, APPNAME, ['sord_test'])
-
-    commands = []
-    for test in good_tests:
-        base_uri = 'http://www.w3.org/2001/sw/DataAccess/df1/' + test.replace('\\', '/')
-        commands += [ 'sordi_static "%s" "%s" > %s.out' % (
-                os.path.join(srcdir, test), base_uri, test) ]
-
-    autowaf.run_tests(ctx, APPNAME, commands, 0, name='good')
-
-    Logs.pprint('BOLD', '\nVerifying turtle => ntriples')
-    for test in good_tests:
-        out_filename = test + '.out'
-        cmp_filename = srcdir + '/' + test.replace('.ttl', '.out')
-        if not os.access(out_filename, os.F_OK):
-            Logs.pprint('RED', 'FAIL: %s output is missing' % test)
-        else:
-            out_lines = sorted(open(out_filename).readlines())
-            cmp_lines = sorted(open(cmp_filename).readlines())
-            if out_lines != cmp_lines:
-                Logs.pprint('RED', 'FAIL: %s is incorrect' % out_filename)
-            else:
-                Logs.pprint('GREEN', 'Pass: %s' % test)
-
-    autowaf.post_test(ctx, APPNAME)
+            'sordi_static -i ntriples > %s' % nul,

=== debian/changelog ===
sord (0.14.0~dfsg0-2) unstable; urgency=medium

  * Add libpcre++-dev as b-dep to build sord_validate binary (Closes: #829508).
  * Fix VCS fields.
  * Bump Standards.
  * Fix some hardening.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Mon, 04 Jul 2016 10:20:55 +0200

sord (0.14.0~dfsg0-1) unstable; urgency=medium

  * Imported Upstream version 0.14.0~dfsg0
  * Refresh patch.
  * Bump Standards.
  * Make watch file more flexible.
  * Patched waf to find generated docs.
  * Enable parallel build.
  * Update symbols file.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Wed, 14 Oct 2015 16:18:53 +0200

=== debian/control ===
--- 
+++ 
@@ -10,12 +10,13 @@
  doxygen,
  graphviz,
  libserd-dev (>= 0.18.0~dfsg0),
+ libpcre++-dev,
  pkg-config,
  python
-Standards-Version: 3.9.5
+Standards-Version: 3.9.8
 Homepage: http://drobilla.net/software/sord/
-Vcs-Git: git://anonscm.debian.org/pkg-multimedia/sord.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/sord.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/sord.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/sord.git
 
 Package: libsord-0-0
 Section: utils

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
 
 upstream_version ?= $(shell dpkg-parsechangelog | sed -rne 's/^Version: ([0-9.]+)(\+dfsg\d+)?.*$$/\1/p')
 dfsg_version = $(upstream_version)~dfsg0
@@ -9,7 +11,7 @@
 WAF = ./waf
 
 %:
-	dh $@
+	dh $@ --parallel
 
 override_dh_auto_configure:
 	$(WAF) configure \

## sord 0.16.0~dfsg0

=== wscript ===
--- 
+++ 
@@ -11,7 +11,7 @@
 # major increment <=> incompatible changes
 # minor increment <=> compatible changes (additions)
 # micro increment <=> no interface changes
-SORD_VERSION       = '0.14.0'
+SORD_VERSION       = '0.16.0'
 SORD_MAJOR_VERSION = '0'
 
 # Mandatory waf variables
@@ -23,13 +23,9 @@
 def options(opt):
     opt.load('compiler_c')
     opt.load('compiler_cxx')
-    autowaf.set_options(opt)
+    autowaf.set_options(opt, test=True)
     opt.add_option('--no-utils', action='store_true', dest='no_utils',
                    help='Do not build command line utilities')
-    opt.add_option('--test', action='store_true', dest='build_tests',
-                   help='Build unit tests')
-    opt.add_option('--no-coverage', action='store_true', dest='no_coverage',
-                   help='Do not use gcov for code coverage')
     opt.add_option('--static', action='store_true', dest='static',
                    help='Build static library')
     opt.add_option('--no-shared', action='store_true', dest='no_shared',
@@ -52,18 +48,14 @@
     autowaf.set_c99_mode(conf)
     autowaf.display_header('Sord configuration')
 
-    conf.env.BUILD_TESTS  = Options.options.build_tests
     conf.env.BUILD_UTILS  = not Options.options.no_utils
     conf.env.BUILD_SHARED = not Options.options.no_shared
     conf.env.STATIC_PROGS = Options.options.static_progs
     conf.env.BUILD_STATIC = (Options.options.static or
                              Options.options.static_progs)
 
-    if conf.env.BUILD_TESTS and not Options.options.no_coverage:
-        conf.check_cc(lib='gcov', define_name='HAVE_GCOV', mandatory=False)
-
     autowaf.check_pkg(conf, 'serd-0', uselib_store='SERD',
-                      atleast_version='0.18.0', mandatory=True)
+                      atleast_version='0.22.4', mandatory=True)
     autowaf.check_pkg(conf, 'libpcre', uselib_store='PCRE', mandatory=False)
 
     if conf.env.HAVE_PCRE:
@@ -146,11 +138,12 @@
         autowaf.use_lib(bld, obj, 'SERD')
 
     if bld.env.BUILD_TESTS:
-        test_libs   = libs
-        test_cflags = ['']
-        if bld.is_defined('HAVE_GCOV'):
-            test_libs   += ['gcov']
-            test_cflags += ['-fprofile-arcs', '-ftest-coverage']
+        test_libs      = libs
+        test_cflags    = ['']
+        test_linkflags = ['']
+        if not bld.env.NO_COVERAGE:
+            test_cflags    += ['--coverage']
+            test_linkflags += ['--coverage']
 
         # Profiled static library for test coverage
         obj = bld(features     = 'c cstlib',
@@ -161,6 +154,7 @@
                   install_path = '',
                   defines      = defines,
                   cflags       = test_cflags,
+                  linkflags    = test_linkflags,
                   lib          = test_libs)
         autowaf.use_lib(bld, obj, 'SERD')
 
@@ -173,7 +167,8 @@
                   target       = 'sord_test',
                   install_path = '',
                   defines      = defines,
-                  cflags       = test_cflags)
+                  cflags       = test_cflags,
+                  linkflags    = test_linkflags)
         autowaf.use_lib(bld, obj, 'SERD')
 
         # Static profiled sordi for tests
@@ -185,7 +180,8 @@
                   target       = 'sordi_static',
                   install_path = '',
                   defines      = defines,
-                  cflags       = test_cflags)
+                  cflags       = test_cflags,
+                  linkflags    = test_linkflags)
         autowaf.use_lib(bld, obj, 'SERD')
 
         # C++ build test
@@ -197,7 +193,9 @@
                       lib          = test_libs,
                       target       = 'sordmm_test',
                       install_path = '',
-                      defines      = defines)
+                      defines      = defines,
+                      cxxflags     = test_cflags,
+                      linkflags    = test_linkflags)
             autowaf.use_lib(bld, obj, 'SERD')
 
     # Utilities
@@ -291,6 +289,16 @@
             'sordi_static %s > %s' % (nul, nul)],
                       0, name='sordi-cmd-good')
 
+    # Test read error by reading a directory
+    autowaf.run_test(ctx, APPNAME, 'sordi_static "file://%s/"' % srcdir,
+                     1, name='read_error')
+
+    # Test write error by writing to /dev/full
+    if os.path.exists('/dev/full'):
+        autowaf.run_test(ctx, APPNAME,
+                         'sordi_static "file://%s/tests/good/manifest.ttl" > /dev/full' % srcdir,
+                         1, name='write_error')
+
     autowaf.run_tests(ctx, APPNAME, [
             'sordi_static > %s' % nul,
             'sordi_static ftp://example.org/unsupported.ttl > %s' % nul,
@@ -298,8 +306,3 @@
             'sordi_static -o > %s' % nul,
             'sordi_static -z > %s' % nul,
             'sordi_static -p > %s' % nul,
-            'sordi_static -c > %s' % nul,
-            'sordi_static -i illegal > %s' % nul,
-            'sordi_static -o illegal > %s' % nul,
-            'sordi_static -i turtle > %s' % nul,
-            'sordi_static -i ntriples > %s' % nul,

=== debian/rules ===
--- 
+++ 
@@ -32,10 +32,6 @@
 override_dh_auto_install:
 	$(WAF) install --destdir=$(CURDIR)/debian/tmp
 
-override_dh_strip:
-	dh_strip -plibsord-0-0 --dbg-package=sord-dbg
-	dh_strip --remaining-packages
-
 override_dh_installchangelogs:
 	dh_installchangelogs NEWS

## sord 0.16.0.1

=== debian/changelog ===
sord (0.16.0.1-1+rebuild) unstable; urgency=low

  * ['Autobuild release-candidate: 8127863d198d832c86753127f316127b93526d42']

 -- shuttle <shuttle@deepin.com>  Tue, 10 Dec 2019 19:58:25 +0000

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  debhelper (>= 9),
  doxygen,
  graphviz,
- libserd-dev (>= 0.18.0~dfsg0),
+ libserd-dev (>= 0.24.0~dfsg0),
  libpcre++-dev,
  pkg-config,
  python
@@ -79,17 +79,3 @@
  Description Framework (RDF) data in memory.
  .
  This package provides the developer's reference for sord.
-
-Package: sord-dbg
-Priority: extra
-Section: debug
-Architecture: any
-Multi-Arch: same
-Depends:
- libsord-0-0 (= ${binary:Version}),
- ${misc:Depends}
-Description: library for storing RDF data in memory (debugging symbols)
- Sord is a lightweight C library for storing Resource
- Description Framework (RDF) data in memory.
- .
- This package provides the debugging symbols for sord.

## sord 0.16.4

=== debian/changelog ===
sord (0.16.4-1) unstable; urgency=medium

  * Team upload

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #929089)
    + Annotate Build-Depends: python with :native.
    + Pass cross tools to waf.

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/control: Set Vcs-* to salsa.debian.org

  [ Felipe Sateler ]
  * Change maintainer address to debian-multimedia@lists.debian.org

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat

  [ Sebastian Ramacher ]
  * New upstream release
  * debian/rules: Remove get-orig-source
  * debian/copyright: Fix waf paragraph
  * debian/control:
    - Bump libserd-dev B-D
    - Remove obsolete Pre-Depends
    - Bump debhelper compat to 12
    - Bump Standards-Version
    - Set RRR: no
    - Fix section of library package
  * debian/: Use python3 to run waf (Closes: #943225)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 08 Dec 2019 21:24:44 +0100

sord (0.16.0~dfsg0-1) unstable; urgency=medium

  * New upstream version 0.16.0~dfsg0
  * Patches refreshed.
  * Tighten B-D for libserd-dev.
  * Doxy patch dropped - not needed.
  * Update copyright file.
  * Update symbols file.
  * Drop dbg package in favour of dbgsym.

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Thu, 22 Sep 2016 20:33:50 +0200

=== debian/control ===
--- 
+++ 
@@ -1,28 +1,27 @@
 Source: sord
 Section: libs
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Alessio Treglia <alessio@debian.org>,
  Jaromír Mikeš <mira.mikes@seznam.cz>
 Build-Depends:
- debhelper (>= 9),
+ debhelper-compat (= 12),
  doxygen,
  graphviz,
- libserd-dev (>= 0.24.0~dfsg0),
+ libserd-dev (>= 0.30),
  libpcre++-dev,
  pkg-config,
- python
-Standards-Version: 3.9.8
+ python3:native,
+Standards-Version: 4.4.1
 Homepage: http://drobilla.net/software/sord/
-Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/sord.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/sord.git
+Vcs-Git: https://salsa.debian.org/multimedia-team/sord.git
+Vcs-Browser: https://salsa.debian.org/multimedia-team/sord
+Rules-Requires-Root: no
 
 Package: libsord-0-0
-Section: utils
 Architecture: any
 Multi-Arch: same
-Pre-Depends: ${misc:Pre-Depends}
 Depends:
  ${misc:Depends},
  ${shlibs:Depends}
@@ -40,7 +39,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libserd-dev (>= 0.18.0~dfsg0),
+ libserd-dev (>= 0.30),
  libsord-0-0 (= ${binary:Version}),
  ${misc:Depends}
 Suggests:

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

include /usr/share/dpkg/architecture.mk
-include /usr/share/dpkg/buildtools.mk
PKG_CONFIG ?= pkg-config
LDFLAGS+=-Wl,--as-needed
WAF = python3 ./waf

%:
	dh $@

override_dh_auto_configure:
	CC=$(CC) PKGCONFIG=$(PKG_CONFIG) \
	$(WAF) configure \
		--prefix=/usr \
		--mandir=/usr/share/man \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--strict \
		--docs

override_dh_auto_build:
	$(WAF)

override_dh_auto_clean:
	$(WAF) clean || true
	find -name "*.pyc" -delete
	dh_auto_clean

override_dh_auto_install:
	$(WAF) install --destdir=$(CURDIR)/debian/tmp

override_dh_installchangelogs:
	dh_installchangelogs NEWS

=== debian/watch ===
version=3
opts="uversionmangle=s/-/./,dversionmangle=s/~dfsg.*//" \
http://download.drobilla.net/sord-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
